<?php

class Tools_SmsServiceFormWatchdog implements Interfaces_Observer
{

    public function notify($object)
    {
        $requestHelper = Zend_Controller_Front::getInstance()->getRequest();
        $formParams = $requestHelper->getParams();
        if (!empty($formParams)) {
            $adminMobilePhones = explode(',', $object->getMobile());
            $subscriber = array();
            $formName = $object->getName();
            $formUrl = $formParams['formUrl'];
            unset($formParams['formUrl']);
            $subscriber['form_url'] = $formUrl;
            $subscriber['form_name'] = $formName;
            $subscriber['sms_from_type'] = Apps::SMS_FROM_TYPE_FORM;

            $customFormParams = array();

            foreach ($formParams as $paramName => $paramValue) {
                $customFormParams[$paramName] = $paramValue;
            }

            if (!empty($adminMobilePhones)) {
                $formId = $object->getId();
                unset($formParams['module']);
                unset($formParams['controller']);
                unset($formParams['action']);
                unset($formParams['recaptcha']);
                unset($formParams[md5($formName . $formId)]);
                unset($formParams['recaptcha_challenge_field']);
                unset($formParams['recaptcha_response_field']);
                unset($formParams['g-recaptcha-response']);
                unset($formParams['formPageId']);
                unset($formParams['submit']);
                unset($formParams['uploadLimitSize']);
                unset($formParams['formName']);
                if (isset($formParams['conversionPageUrl'])) {
                    unset($formParams['conversionPageUrl']);
                }
                $messageAdmin = 'Hello you\'ve received a request from: ' . $formUrl. PHP_EOL;

                foreach ($formParams as $name => $value) {
                    if (!$value) {
                        continue;
                    }
                    $messageAdmin .= $name . ': ' . (is_array($value) ? implode(', ', $value) : $value) . PHP_EOL;
                }

                $adminMobiles = array();

                foreach($adminMobilePhones as $adminMobile) {
                    $mobilePhoneAdmin = Apps_Tools_Twilio::normalizePhoneNumberToE164($adminMobile);
                    if ($mobilePhoneAdmin) {
                        array_push($adminMobiles, $mobilePhoneAdmin);
                    }
                }

                if (!empty($adminMobiles)) {
                    $subscriber['subscriber']['admin'] = array(
                        'phone' => $adminMobiles,
                        'message' => $messageAdmin,
                        'owner_type' => Apps::SMS_OWNER_TYPE_ADMIN,
                        'custom_params' => $customFormParams
                    );
                }

            }

            $enabledSms = $object->getEnableSms();

            if (isset($formParams['mobile']) && $enabledSms) {

                if(!empty($formParams['mobilePhoneCode'])) {
                    $formParams['mobile'] = $formParams['mobilePhoneCode'] . $formParams['mobile'];
                }

                $mobilePhoneUser = Apps_Tools_Twilio::normalizePhoneNumberToE164($formParams['mobile']);
                $messageUser = $object->getReplyText();

                if ($mobilePhoneUser) {
                    $subscriber['subscriber']['user'] = array(
                        'phone' => array($mobilePhoneUser),
                        'message' => $messageUser,
                        'owner_type' => Apps::SMS_OWNER_TYPE_USER,
                        'custom_params' => $customFormParams
                    );
                }
            }
            if (!empty($subscriber['subscriber'])) {
                Apps::apiCall('POST', 'apps', array('twilioSms'), $subscriber);
            }
        }
    }


}

