CREATE TABLE IF NOT EXISTS `plugin_emailsequence_settings` (
  `id` INT(10) UNSIGNED AUTO_INCREMENT NOT NULL,
  `sequence_name` VARCHAR(255) NOT NULL COLLATE 'utf8_unicode_ci',
  PRIMARY KEY (`id`),
  UNIQUE (`sequence_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `plugin_emailsequence_triggers` (
  `sequence_settings_id` INT(10) UNSIGNED NOT NULL,
  `trigger_id` INT(10) UNSIGNED NOT NULL,
  `trigger_enabled` ENUM('0', '1') DEFAULT '0',
  PRIMARY KEY (`sequence_settings_id`, `trigger_id`),
  FOREIGN KEY (`sequence_settings_id`) REFERENCES `plugin_emailsequence_settings`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION,
  FOREIGN KEY (`trigger_id`) REFERENCES `plugin_cartstatusemail_settings`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

UPDATE `plugin` SET `tags`='ecommerce,merchandising,cartstatusemail' WHERE `name` = 'emailsequence';