-- 09/10/2017
-- version: 1.0.0
CREATE TABLE IF NOT EXISTS `plugin_leads_events` (
  `id` INT(10) UNSIGNED AUTO_INCREMENT NOT NULL,
  `event_name` VARCHAR(255) COLLATE utf8_unicode_ci NOT NULL,
  `event_label` VARCHAR(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY(`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `plugin_leads_events_relation` (
  `event_id` INT(10) UNSIGNED NOT NULL,
  `external_id` VARCHAR(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY(`event_id`, `external_id`),
  FOREIGN KEY(`event_id`) REFERENCES `plugin_leads_events` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `plugin_leads_event_rules_general_config` (
  `id` INT(10) UNSIGNED AUTO_INCREMENT NOT NULL,
  `event_id` INT(10) UNSIGNED NOT NULL,
  `rule_name` VARCHAR(255) COLLATE utf8_unicode_ci NOT NULL,
  `created_at` TIMESTAMP NOT NULL,
  `creator_id` INT(10) UNSIGNED DEFAULT NULL,
  `updated_at` TIMESTAMP NOT NULL,
  `editor_id` INT(10) UNSIGNED DEFAULT NULL,
  PRIMARY KEY(`id`),
  FOREIGN KEY (`creator_id`) REFERENCES `user` (`id`) ON DELETE SET NULL ON UPDATE NO ACTION,
  FOREIGN KEY (`editor_id`) REFERENCES `user` (`id`) ON DELETE SET NULL ON UPDATE NO ACTION,
  FOREIGN KEY (`event_id`) REFERENCES `plugin_leads_events` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION,
  UNIQUE (`rule_name`, `event_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `plugin_leads_event_rules_config` (
  `id` INT(10) UNSIGNED AUTO_INCREMENT NOT NULL,
  `rule_id` INT(10) UNSIGNED NOT NULL,
  `field_name` VARCHAR (255) COLLATE utf8_unicode_ci NOT NULL,
  `rule_comparison_operator` ENUM('equal', 'notequal', 'like', 'in') DEFAULT 'equal',
  `field_value` MEDIUMTEXT COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY(`id`),
  FOREIGN KEY (`rule_id`) REFERENCES `plugin_leads_event_rules_general_config` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `plugin_leads_event_rules_actions` (
  `id` INT(10) UNSIGNED AUTO_INCREMENT NOT NULL,
  `rule_id` INT(10) UNSIGNED NOT NULL,
  `action_type` ENUM ('assign_owner', 'assign_task', 'assign_tags', 'assign_lifecycle') DEFAULT 'assign_owner',
  `action_config` TEXT COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY(`id`),
  UNIQUE(`rule_id`, `action_type`),
  FOREIGN KEY (`rule_id`) REFERENCES `plugin_leads_event_rules_general_config` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

ALTER TABLE `plugin_leads_form_rules_actions` MODIFY COLUMN `action_type` ENUM ('assign_owner', 'assign_task', 'assign_tags', 'assign_lifecycle') DEFAULT 'assign_owner';
ALTER TABLE `plugin_leads_call_log` ADD COLUMN `call_source` VARCHAR(255) DEFAULT NULL;
ALTER TABLE `plugin_leads_call_log` ADD COLUMN `receiver` VARCHAR(20) COLLATE utf8_unicode_ci DEFAULT NULL;

-- 09/10/2017
-- version: 1.1.0
ALTER TABLE `plugin_leads_ips` MODIFY COLUMN `lead_ip_address` VARCHAR(45) NOT NULL;
ALTER TABLE `plugin_leads_last_viewed` MODIFY COLUMN `viewed_at` TIMESTAMP NOT NULL;

-- 16/11/2017
-- version: 1.2.0
ALTER TABLE `plugin_leads_form_rules_actions` MODIFY COLUMN `action_type` ENUM ('assign_owner', 'assign_task', 'assign_tags', 'assign_lifecycle', 'assign_sequence') DEFAULT 'assign_owner';
ALTER TABLE `plugin_leads_event_rules_actions` MODIFY COLUMN `action_type` ENUM ('assign_owner', 'assign_task', 'assign_tags', 'assign_lifecycle', 'assign_sequence') DEFAULT 'assign_owner';

-- 20/11/2017
-- version: 1.2.1
ALTER TABLE `plugin_leads_form_rules_actions` MODIFY COLUMN `action_type` ENUM ('assign_owner', 'assign_task', 'assign_tags', 'assign_lifecycle', 'assign_sequence', 'assign_email_copy') DEFAULT 'assign_owner';

-- 28/11/2017
-- version: 1.2.2
ALTER TABLE `plugin_leads_registration_log` MODIFY COLUMN `last_name` VARCHAR(255) COLLATE utf8_unicode_ci DEFAULT NULL;
ALTER TABLE `plugin_leads_registration_log` MODIFY COLUMN `mobile` VARCHAR(255) COLLATE utf8_unicode_ci DEFAULT NULL;

-- 16/11/2017
-- version: 1.2.3
ALTER TABLE `plugin_leads_event_rules_actions` MODIFY COLUMN `action_type` ENUM ('assign_owner', 'assign_task', 'assign_tags', 'assign_lifecycle', 'assign_sequence', 'assign_email_copy') DEFAULT 'assign_owner';

-- 09/11/2017
-- version: 1.2.4
CREATE TABLE IF NOT EXISTS `plugin_leads_builder_form_general_config` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `form_name` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `form_type` enum('internal','external') COLLATE utf8_unicode_ci DEFAULT 'internal',
  `form_title` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `form_domain` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `form_button_label` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `form_code` MEDIUMTEXT COLLATE utf8_unicode_ci,
  `form_signature` char(40) COLLATE utf8_unicode_ci NOT NULL,
  `recaptcha_public_key` VARCHAR(255) DEFAULT NULL,
  `recaptcha_private_key` VARCHAR(255) DEFAULT NULL,
  `success_url` VARCHAR(255) DEFAULT NULL,
  `fail_url` VARCHAR(255) DEFAULT NULL,
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `creator_id` int(10) unsigned DEFAULT NULL,
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `editor_id` int(10) unsigned DEFAULT NULL,
  `send_email` ENUM('0', '1') DEFAULT '0',
  `send_auto_reply` ENUM('0', '1') DEFAULT '0',
  `send_email_config` MEDIUMTEXT COLLATE utf8_unicode_ci DEFAULT NULL,
  `send_auto_reply_config` MEDIUMTEXT COLLATE utf8_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `form_name` (`form_name`),
  KEY `creator_id` (`creator_id`),
  KEY `editor_id` (`editor_id`),
  CONSTRAINT `plugin_leads_builder_form_general_config_ibfk_1` FOREIGN KEY (`creator_id`) REFERENCES `user` (`id`) ON DELETE SET NULL ON UPDATE NO ACTION,
  CONSTRAINT `plugin_leads_builder_form_general_config_ibfk_2` FOREIGN KEY (`editor_id`) REFERENCES `user` (`id`) ON DELETE SET NULL ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `plugin_leads_builder_form_fields` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `form_id` int(10) unsigned NOT NULL,
  `field_name` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `field_label` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `field_value` mediumtext COLLATE utf8_unicode_ci DEFAULT NULL,
  `field_data` text COLLATE utf8_unicode_ci NOT NULL,
  `field_type` VARCHAR (255) COLLATE utf8_unicode_ci NOT NULL,
  `system_type` VARCHAR (255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `form_id` (`form_id`),
  CONSTRAINT `plugin_leads_builder_form_fields_ibfk_1` FOREIGN KEY (`form_id`) REFERENCES `plugin_leads_builder_form_general_config` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

ALTER TABLE `plugin_leads_form_log` ADD COLUMN `form_type` ENUM('internal', 'external') DEFAULT 'internal';

-- 19/01/2018
-- version: 1.2.5
ALTER TABLE `plugin_leads_data` CHANGE `suffix` `prefix` VARCHAR (255) COLLATE utf8_unicode_ci DEFAULT NULL;

-- 18/01/2018
-- version: 1.2.6
ALTER TABLE `plugin_leads_quote_log` MODIFY COLUMN `status` ENUM('new','sent','sold','lost', 'deleted') DEFAULT 'new';
ALTER TABLE `plugin_leads_quote_log` MODIFY COLUMN `quote_action_type` ENUM('view', 'change', 'deleted') DEFAULT 'change' NOT NULL;
ALTER TABLE `plugin_leads_quote_log` ADD COLUMN `is_deleted` ENUM('0', '1') DEFAULT '0';
ALTER TABLE `plugin_leads_quote_log` ADD COLUMN `deleted_by` int(10) unsigned DEFAULT NULL;

-- 27/11/2017
-- version: 1.2.7
ALTER TABLE `plugin_leads_data` ADD COLUMN `last_activity_outbound` TIMESTAMP NULL DEFAULT '0000-00-00 00:00:00';

UPDATE `plugin_leads_data` SET `last_activity_outbound` = `last_activity` WHERE `last_activity_type_id` IN(SELECT `id` FROM `plugin_leads_type` WHERE `type_name` IN(
'outbound_email',
'outbound_call',
'outbound_quote',
'outbound_meeting',
'outbound_task',
'outbound_opened',
'outbound_openattachment',
'opened',
'openattachment'));

-- 30/01/2018
-- version: 1.2.8
ALTER TABLE `plugin_leads_tasks` ADD COLUMN `is_task_completed` ENUM('0', '1') DEFAULT '0';
ALTER TABLE `plugin_leads_tasks` ADD COLUMN `task_completed_by` INT(10) UNSIGNED DEFAULT NULL;
ALTER TABLE `plugin_leads_tasks` ADD COLUMN `completion_comment` TEXT COLLATE utf8_unicode_ci DEFAULT NULL;
ALTER TABLE `plugin_leads_tasks` MODIFY `expired_at` TIMESTAMP NULL;
ALTER TABLE `plugin_leads_tasks_log` MODIFY `expired_at` TIMESTAMP NULL;
ALTER TABLE `plugin_leads_tasks_log` ADD COLUMN `is_task_completed` ENUM('0', '1') DEFAULT '0';
ALTER TABLE `plugin_leads_tasks_log` ADD COLUMN `task_completed_by` INT(10) UNSIGNED DEFAULT NULL;
ALTER TABLE `plugin_leads_tasks_log` ADD COLUMN `completion_comment` TEXT COLLATE utf8_unicode_ci DEFAULT NULL;

INSERT INTO `email_triggers` (`enabled`, `trigger_name`, `observer`) VALUES
('1', 'leads_taskcompleted', 'Tools_LeadsMailWatchdog'),
('1', 'leads_taskreopened', 'Tools_LeadsMailWatchdog');

-- 27/02/2018
-- version: 1.2.9
UPDATE `plugin` SET `tags`='crm,hiddenemail,emaillog' WHERE `name` = 'leads';

-- 07/03/2018
-- version: 1.3.0
UPDATE `plugin_leads_tasks` SET `is_task_completed` = '0' WHERE `is_task_completed` IS NULL;
UPDATE `plugin_leads_tasks_log` SET `is_task_completed` = '0' WHERE `is_task_completed` IS NULL;

-- These alters are always the latest and updated version of the database
UPDATE `plugin` SET `version`='1.3.1' WHERE `name`='leads';
SELECT version FROM `plugin` WHERE `name` = 'leads';