define([
    'backbone',
    './industry-type-form.js',
    './industry-type-grid.js'
], function(Backbone,
            IndustryTypeFormView, IndustryTypeGridView){
    var LeadCrmConfigMainView = Backbone.View.extend({
        el: $('#industry-crm-config-block'),
        events:{
            'submit #industry-type-search-form' : 'search'
        },
        templates: {},
        initialize: function(){
            showSpinner();

            this.$el = $('#industry-crm-config-block');

            this.IndustryTypeForm = new IndustryTypeFormView();
            this.IndustryTypeForm.render();

            this.IndustryTypeGrid = new IndustryTypeGridView();
            this.IndustryTypeGrid.IndustryTypes.server_api.searchTerm = '';
            this.IndustryTypeGrid.render();

            this.IndustryTypeForm.$el.on('IndustryTypeForm:created', _.bind(this.IndustryTypeGrid.render, this.IndustryTypeGrid));

        },
        search : function (e) {
            e.preventDefault();
            this.IndustryTypeGrid.IndustryTypes.server_api.searchTerm = $('#search-term').val();
            this.IndustryTypeForm.$el.trigger('IndustryTypeForm:created');
        }
    });

    return LeadCrmConfigMainView;
});