define([
    'backbone',
    './lead-grid',
    'i18n!../../../nls/dashboard_'+$('#main-dashboard-system-language').val()+'_ln'
], function(Backbone, LeadGridView, i18n
){

    var LeadsGridView = Backbone.View.extend({
        el: $('#lead-block'),
        events: {
            'click #switch-lead-creation': 'toggleLeadCreation',
            'click #lead-filters-switch': 'toggleLeadAdditionalFilters',
            'click #lead-filter-apply': 'applyFilter',
            'click #lead-filter-reset': 'resetFilter',
            'click #lead-filter-reset-top': 'resetFilter',
            'click #go-to-lead-profile, a[data-role=lead-detailed-view]': 'showLeadDetailsScreen',
            'submit #filters-form':'applyFilter',
            'click #lead-filter-by-special-type, #lead-filter-by-special-type':'changeFilterSpecialType'
        },
        templates: {},
        initialize: function(options){

        },
        render: function(){

        },
        toggleLeadCreation: function(e){
            e.preventDefault();
            $('#lead-form').slideToggle();
        },
        toggleLeadAdditionalFilters: function(){
            $("#lead-additional-filters").toggleClass('hidden');
        },
        applyFilter: function(e) {
            if(typeof e !== 'undefined'){
                e.preventDefault();
            }
            this.LeadGrid = new LeadGridView();
            this.LeadGrid.leadsChecked = [];
            this.LeadGrid.currentPage = 0;
            this.LeadGrid.render();
        },
        changeFilterSpecialType: function(e)
        {
            var el = $(e.currentTarget),
                currentStatus = el.data('checked');

            $('.leadFilterBySpecialType').prop('checked', false).data('checked', false);
            if (currentStatus === true) {
                el.prop('checked', false);
                el.data('checked', false);
            } else {
                el.prop('checked', true);
                el.data('checked', true);
            }
        },
        resetFilter: function(e){
            e.preventDefault();
            var $el = $('#lead-additional-filters');
            $el.find('input:text').val('');
            $el.find('select.filter').val('0').trigger('chosen:updated');
            $('#lead-filter-by-interaction').val('created_at');
            $('#lead-filter-by-special-type-existing-client').prop('checked', false);
            $('#lead-filter-by-special-type-prospect').prop('checked', false);
            $('#switch-created-date').prop('checked', true);
            $('#switch-updated-date').prop('checked', false);
            $('#lead-attribute').val('');
            $('#lead-search-by-keyword1').prop('checked', true);
            $('#lead-search-by-keyword2').prop('checked', false);
            this.applyFilter();
        },
        showLeadDetailsScreen: function(e)
        {
            var leadId = $(e.currentTarget).data('cid');
            if (!leadId) {
                return false;
            }
            window.appLeadRouter.leadDetails(leadId);
        }
    });

    return LeadsGridView;
});