define([
    'backbone',
    './organization-form',
    './organization-grid',
    './organization-filter-preset-config',
    './organization-detailed-info',
    '../models/organization',
    './organization-main',
    '../../leads/views/lead-recently-viewed'
], function(Backbone,
            OrganizationFormView, OrganizationGridView, OrganizationFilterPresetConfig, OrganizationDetailedView, OrganizationModel, OrganizationMainView, LeadRecentlyViewedView){
    var OrganizationsRouter = Backbone.Router.extend({

        routes: {
            ''         : 'index',
            'organization/:id' : 'leadOrganizationDetails'
        },
        index: function (){
            //init organization grid data
            $('#lead-organization-block').removeClass('hidden');
            this.OrganizationForm = new OrganizationFormView();
            this.OrganizationForm.render();

            this.OrganizationGrid = new OrganizationGridView();
            this.OrganizationGrid.render();

            this.recentlyViewed = new LeadRecentlyViewedView();
            this.recentlyViewed.render();

            this.OrganizationForm.$el.on('LeadOrganizationForm:created', _.bind(this.OrganizationGrid.render, this.OrganizationGrid));
            this.OrganizationGrid.$el.on('LeadOrganizationStatus:changed', _.bind(this.OrganizationGrid.render, this.OrganizationGrid));

            this.OrganizationFilterPreset = new OrganizationFilterPresetConfig();
            this.OrganizationFilterPreset.render();

            this.OrganizationMainView = new OrganizationMainView();
            this.OrganizationMainView.render();

        },
        leadOrganizationDetails: function(organizationId)
        {
            if (!organizationId) {
                return false;
            }

            this.OrganizationModel =  new OrganizationModel();
            this.OrganizationModel.set('id', organizationId);
            this.OrganizationModel.fetch({data: { isGrid: true, detailedInfo:true},
                'success': function(OrganizationModel){
                    if(_.isUndefined(OrganizationModel.get('organization_name'))) {
                        window.location.href = window.location.pathname;
                    } else {
                        if(!_.isUndefined(this.OrganizationDetailed)) {
                            this.OrganizationDetailed.$el.unbind();
                        }
                        $('#lead-organizations-recently-viewed-block').addClass('hidden');
                        this.OrganizationDetailed = new OrganizationDetailedView(OrganizationModel);
                        window.OrganizationDetailed = this.OrganizationDetailed;
                        this.OrganizationDetailed.render();
                        $('#lead-organization-table-block').hide();
                        $('.lead-organization-filters').hide();
                        $('#lead-organization-grid-back-link').removeClass('hidden');
                        $('#lead-organization-block').removeClass('hidden');
                        $('#lead-organization-additional-filters').hide();
                        if (window.location.hash !== '') {
                            $('#lead-organization-grid-back').attr('href', $('#website_url').val()+'dashboard/organizations/');
                        }
                        $.post($('#website_url').val()+'plugin/leads/run/logLastViewed/', {'id':organizationId, 'secureToken':$('#lead-organization-grid-token').val(), 'type':'organization'}, function(){
                        }, 'json');
                    }
                }
            });
        }

    });

    var initialize = function() {
        window.appLeadOrganizationRouter = new OrganizationsRouter();
        Backbone.history.start();
    };

    return {
        initialize: initialize
    };
});